﻿package codeonwort.ui {
	
	import flash.ui.Keyboard;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.EventDispatcher;
	import flash.display.InteractiveObject;
	
	import flash.system.IME;
	import flash.system.IMEConversionMode;
	import flash.system.Capabilities;
	
	/*
		제작자 블로그 주소 :  http://codeonwort.tistory.com
		MPL 라이센스 하에 배포합니다.
	*/
	public class KeyPress extends EventDispatcher {
		
		public static const IME_ERROR:String = "IMEError";
		public static const KEY_PRESS:String = "keyPress";
		
		private var _io:InteractiveObject;
		private var _keys:Object = {};
		private var _pressed:Boolean = false;
		
		private var _koreanToEnglish:Boolean = false;
		
		public function KeyPress(io:InteractiveObject, autoWake:Boolean=true) {
			_io = io;
			if(autoWake) wake();
		}
		
		public function wake():void {
			_io.addEventListener(KeyboardEvent.KEY_DOWN, io_keyDown);
			_io.addEventListener(KeyboardEvent.KEY_UP, io_keyUp);
		}
		
		public function sleep():void{
			_io.removeEventListener(KeyboardEvent.KEY_DOWN, io_keyDown);
			_io.removeEventListener(KeyboardEvent.KEY_UP, io_keyUp);
		}
		
		public function get koreanToEnglish():Boolean {
			return _koreanToEnglish;
		}
		public function set koreanToEnglish(value:Boolean):void {
			_koreanToEnglish = value;
			if(value){
				try{
					IME.enabled = true;
					IME.conversionMode = IMEConversionMode.ALPHANUMERIC_HALF;
				}catch(Error){
					dispatchEvent(new Event(IME_ERROR));
					_koreanToEnglish = false;
				}
			}
		}
		
		///////////////////////////////////////////////////////////////////////
		// listeners
		
		private function io_keyDown(e:KeyboardEvent):void {
			if(_koreanToEnglish && e.keyCode==229){
				IME.conversionMode = IMEConversionMode.ALPHANUMERIC_HALF;
			}
			
			if(_keys[e.keyCode] == null){
				_keys[e.keyCode] = true;
				dispatchEvent(new KeyboardEvent(KEY_PRESS,e.bubbles,e.cancelable,e.charCode,e.keyCode,
												e.keyLocation,e.ctrlKey,e.altKey,e.shiftKey));
			}
		}
		
		private function io_keyUp(e:KeyboardEvent):void {
			/*this.dispatchEvent(new KeyboardEvent("keyRelease",true,false,e.charCode,e.keyCode,
												 e.keyLocation,e.ctrlKey,e.altKey,e.shiftKey));*/
			delete _keys[e.keyCode];
		}
		
	}
	
}
